Summary: Module for configuring the IMAP server
%define name e-smith-imap
Name: %{name}
%define version 1.0.0
%define release 02
Version: %{version}
Release: %{release}
License: GPL
Vendor: Mitel Networks Corporation
Group: Networking/Daemons
Source: %{name}-%{version}.tar.gz
Patch0: e-smith-imap-1.0.0-02.mitel_patch
Packager: e-smith developers <bugs@e-smith.com>
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-buildroot
Requires: ucspi-tcp daemontools
Requires: stunnel
Requires: mailfront
Requires: dovecot
Requires: e-smith-cvm-unix-local
Requires: e-smith-lib >= 1.13.1-90
Obsoletes: imap
Obsoletes: e-smith-wu-imap
BuildArchitectures: noarch
BuildRequires: e-smith-devtools
AutoReqProv: no
%define stunnelid 451
%define imaplogid 1001

%description
Module for configuring the IMAP server

%changelog
* Wed Jul  9 2003 Gordon Rowell <gordonr@e-smith.com>
- [1.0.0-02]
- Remove event name check in email-relocate-maildirs [gordonr 9337]

* Thu Jun 26 2003 Charlie Brady <charlieb@e-smith.com>
- [1.0.0-01]
- Changing version to stable stream number - 1.0.0

* Mon Jun 23 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.5-07]
- Template /etc/dovecot.conf and runenv/* dovecot environment setup files.
  Rename conf-imap-tcprules to conf-imap to cover additional template
  expansions.  [charlieb 587]
- Increase default ulimit setting to 128MB. [charlieb 9113]

* Thu Jun 19 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.5-06]
- Update tcpserver's cdb file in email-update and remoteaccess-update.
  [charlieb 9068]

* Wed Jun  4 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.5-05]
- Use create-system-user to create imaplog user. Add Requires header to ensure
  that %pre script can run. [charlieb 6033]

* Tue Jun  3 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.5-04]
- Fix %pre script so that uid other than expected generates warning,
  but install proceeds. [charlieb 6033]

* Thu Apr 24 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.5-03]
- Do maildir relocation in two steps, first move top level folders into
  ~/Mail, then do depthwise move and rename into Maildir. Much faster too.
  [charlieb 8273]

* Thu Apr 24 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.5-02]
- Redo maildir relocation to account for leading ;. [charlieb 8272]
- Rewrite subscription files contents, to change hierarchy separator, and to
  omit leading Mail/. [charlieb 8272]
- For now, do not relocate ~admin maildirs - we need to work out how to avoid walking
  all of /home/e-smith/files. [charlieb 8273]

* Thu Apr 24 2003 Gordon Rowell <gordonr@e-smith.com>
- [0.0.5-01]
- Rebuild tarball [gordonr 587]

* Tue Apr 22 2003 Mark Knox <markk@e-smith.com>
- [0.0.4-01]
- Updated Summary to reflect actual contents [markk 8272]
- Fixed file list generation to include all files [markk 8272]

* Fri Apr 18 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.3-01]
- Break runenv into runenv and imapfront.env - we don't need export
  this way. [charlieb 8281]
- Make sure that PRNG file is initialisedbefore we run tcpserver.
  [charlieb 8281]

* Fri Apr 18 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-15]
- Ensure that runenv environment is exported (we should break this
  into exportenv and runenv). [charlieb 8281]

* Fri Apr 18 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-14]
- Remove %post creation of SSL PRNG seed file, and change filelist
  from %ghost to %config(noreplace). [charlieb 8281]
- Setup SASL evvironment for imap run file via runenv directory.
  Allow override of imap path from runenv. [charlieb 587]

* Thu Apr 17 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-13]
- Remove group write permission on SSL PRNG seed file. [charlieb 8281]

* Thu Apr 17 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-12]
- Fix chown => chmod typo. [charlieb 8281]
- Move .mailboxlist files to Maildir/.subscriptions. [charlieb 8274]

* Tue Apr 15 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-11]
- Fix permissions problem in imapd certificate file. [charlieb 8281]
- Add maildir relocate script (from e-smith-email) and rewrite it
  to provide new locations compatible with dovecot. [charlieb 8273]

* Thu Apr  3 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-10]
- Remove email-relocate-maildirs script - it lives in e-smith-email, and
  we haven't modified it yet. [charlieb 587]

* Thu Apr  3 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-09]
- Remove "-D debug" from stunnel args in imap/run - we can't have
  passwords logged in plaintext. [charlieb 587]

* Tue Apr  1 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-08]
- Fix rpm build problem with last change - missing directories. [charlieb 587]

* Tue Apr  1 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-07]
- Create imapd.pem certificate in the place where it is required. Add
  rc7.d startup script so that imap runs on startup. [charlieb 587]

* Fri Mar 21 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-06]
- Fix tcpserver CDB file name. [charlieb 587]
- Ansure that stunnel user is created in %pre. [charlieb 587]
- Allow various settings for run script to be set from
  an envdir, including imap daemon executable path. [charlieb 587]

* Fri Mar 21 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-05]
- Fix spec file to generate filelist from repository (where possible).
  [charlieb 687]

* Fri Mar 21 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-04]
- Include action scripts in RPM file list. [charlieb 587]

* Fri Mar 21 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-03]
- Add minimal chroot jail for stunnel [charlieb 587]

* Fri Mar 21 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-02]
- Add dependency on e-smith-cvm-unix-local - which itself depends
  on cvm. [charlieb 587]

* Fri Mar 21 2003 Charlie Brady <charlieb@e-smith.com>
- [0.0.2-01]
- Add PEM certificate create/update action. Add tcprules update action.
  [charlieb 587]
- Add Obsoletes headers to force removal of e-smith-wu-imap and imap RPMs.
  Add dependency on dovecot RPM. [charlieb 587]

* Thu Mar 20 2003 Charlie Brady <charlieb@e-smith.com>
- Initial

%prep
%setup
%patch0 -p1

%build
perl createlinks
mkdir -p root/etc/rc.d/init.d
ln -s daemontools root/etc/rc.d/init.d/imap
mkdir -p root/etc/rc.d/rc7.d
ln -s /etc/rc.d/init.d/e-smith-service root/etc/rc.d/rc7.d/S55imap

%install
rm -rf $RPM_BUILD_ROOT
(cd root   ; find . -depth -print | cpio -dump $RPM_BUILD_ROOT)
mkdir -p $RPM_BUILD_ROOT/service
ln -s /var/service/imap $RPM_BUILD_ROOT/service/imap

mkdir -p $RPM_BUILD_ROOT/var/log/imap
touch $RPM_BUILD_ROOT/var/service/imap/down
mkdir -p $RPM_BUILD_ROOT/var/service/imap/ssl/{dev,usr/share/ssl}
touch $RPM_BUILD_ROOT/var/service/imap/ssl/seed

mkdir -p $RPM_BUILD_ROOT/var/service/imap/runenv/
echo %{stunnelid} > $RPM_BUILD_ROOT/var/service/imap/runenv/SSLUID
echo %{stunnelid} > $RPM_BUILD_ROOT/var/service/imap/runenv/SSLGID

/sbin/e-smith/genfilelist $RPM_BUILD_ROOT \
    | sed \
      -e 's@^/var/service/imap/log/run$@%attr(0755,root,root) &@' \
      -e 's@^\(.*)\)\( /var/service/imap/log$\)@%dir %attr(0755,root,root) \2@' \
      -e 's@^/var/service/imap/run$@%attr(0755,root,root) &@' \
      -e 's@^\(.*)\)\( /var/service/imap/runenv$\)@%dir %attr(0755,root,root) \2@' \
      -e 's@^/var/service/imap/ssl/seed$@%config(noreplace) %attr(0600,stunnel,stunnel) &@' \
      -e 's@^\(.*)\)\( /var/service/imap/ssl/usr.*$\)@%dir %attr(0755,root,root) \2@' \
      -e 's@^\(.*)\)\( /var/service/imap/ssl/dev$\)@%dir %attr(0755,root,root) \2@' \
      -e 's@^\(.*)\)\( /var/service/imap/ssl$\)@%dir %attr(0755,root,root) \2@' \
      -e 's@^/var/service/imap/runenv/.*$@%attr(0644,root,root) &@' \
      -e 's@^\(.*)\)\( /var/service/imap$\)@%dir %attr(1755,root,root) \2@' \
      -e 's@^\(.*)\)\( /var/log/imap$\)@%dir %attr(0750,imaplog,imaplog) \2@' \
      -e 's@^/var/service/imap/ssl/usr/share/ssl/openssl.cnf$@%attr(0644,root,root) &@' \
    > %{name}-%{version}-%{release}-filelist

%pre
/sbin/e-smith/create-system-user stunnel %{stunnelid} \
    'chrooted stunnel user user' /var/log/imap/ssl /bin/false
/sbin/e-smith/create-system-user imaplog %{imaplogid} \
    'imap output log user' /var/log/imap /bin/false

%preun
if [ "$1" = 0 ]
then
    # Make sure that imap is not running
    svc-stop imap
    # Now get svscan to forget about it
    svc-remove imap
fi

%post

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}-%{version}-%{release}-filelist
%defattr(-,root,root)
